/*===========================================================================
							 .
		     TDA7313D.
 - . . .
. -
kpmic@yandex.ru
===========================================================================*/
#include <16F877A.h>
#device ADC=10
#use delay(clock=20000000)
#use i2c(Master,sda=PIN_B7,scl=PIN_B6,RESTART_WDT,SLOW)
#fuses HS, NOWDT, NOLVP, NODEBUG
#byte ADCON0 = 0xFF					//    A.
/*---------------------------------------------------------------------------
								 
---------------------------------------------------------------------------*/
//	 	   {  Loud,Bass,B2,Treb,T2, LF , RF , LR , RR }
unsigned char Const_Temp[10] = {0,0x19,0x0A, 1,0x08, 1,0x00,0x00,0x00,0x00};
unsigned char Constants[10] =  {0,0x19,0x0A, 1,0x08, 1,0x00,0x00,0x00,0x00};
unsigned char Digit[9] = {0,0,0,0,0,0,0,0,0}; // .    .
unsigned char c;
unsigned char d;	 				//  .
unsigned char bit_mask;				//    .
unsigned int16 Volt[5] = {0,0,0,0x0050,0xFFFF};
unsigned int16 num[9] = {0,0,0,0,0,0,0,0,0,}; //  .
unsigned char i = 0;
unsigned char ColStolb_1 = 0;
unsigned char Out_Dat = 0;
unsigned char adress = 11;			//   EEPROM.
unsigned char inter = 0;
unsigned int16 RC5 = 0;
unsigned char Temp[3] = {0,0,0};
unsigned char Cristal[5] = {0,0,0,0,0};
unsigned char Page = 0;						//  .
unsigned char Change_Regim = 0;
unsigned char buf_0[9] = {0,' ',' ',' ',' ',' ',' ',' ',' '};
unsigned char buf_5[9] = {0,'','','','','','','',' '};
unsigned char buf_6[9] = {0,'','','','','','','',' '};
unsigned char buf_7[9] = {0,' ','','','','','','',' '};
unsigned char buf_8[9] = {0,'','','','','','','',' '};
unsigned char buf_9[9] = {0,' ',' ',' ',' ',' ',' ',' ',' '};
/*---------------------------------------------------------------------------
							 .
---------------------------------------------------------------------------*/
//#include "1-WIRE.c"			//     1-WIRE.
#include "Tab_Simb_Rus.c"	//  .
#include "Displey.c"		//     .
#include "RC5.c"			//     RC5.
/*===========================================================================
					   .
===========================================================================*/
#int_ext
void ext_isr()
{
unsigned char in = 0;
unsigned int16 cnt_Takt = 15;
unsigned int16 cnt_T = 0;
	output_low(PIN_D2);			//  .

	output_float(PIN_B0);		//     .
	cnt_Takt = 19;
	while (cnt_Takt > 0)		//    .
	{
	delay_us(1778);				//  1778 .
	cnt_Takt--;
	}
	while (input(PIN_B0) == 1)
	{
		cnt_T = 5000;
		while (cnt_T > 0)
		{
		output_high(PIN_B5);	//   Stand_BY.
		delay_us(50);
		if (input(PIN_B0) == 0) goto exit_normal;	//  .
		cnt_T--;
		RC5 = 0;				//   ,   .
		inter = 2;
		if (cnt_T == 0) goto exit_inter;
		}
	}							//    .
exit_normal:
	inter = 1;
	RC5 = 0;
	for (in=0; in<16; in++)		//  2 .
	{
	delay_us(1300);				//  1300 .
		if (input(PIN_B0) == 1)	//   .
		{
		bit_set(RC5, 0);		//  . 1
		if (in < 15)
		RC5 <<= 1;				//    1 .
		}
		else
		{
		bit_clear(RC5, 0);		//  . 0
		if (in < 15)
		RC5 <<= 1;				//    1 .
		}
	delay_us(478);				//  478 .
	}
exit_inter:
	output_low(PIN_B5);			//   Stand_BY..
	delay_ms(10);
	RC5 = RC5 & 0x0FFF;
}
/*===========================================================================
                        		  .
===========================================================================*/
void char WORD_to_BCD();
void read_memory();
void write_memory();
void Infa();
void Multimetr_Canal_0();
void Multimetr_Canal_1();
void Multimetr_Canal_2();
void Multimetr_Canal_3();
void Remote_Control();
void Analog_ON();
void init_TDA7313();
void Tembr_dB();
void tembr_ind();
void Load_Regim();
/*-------------------------------------------------------------------------*/
void main()
{
	port_b_pullups(TRUE);		//   
								//   .
	setup_adc_ports(ALL_ANALOG);	// ADCON1
	setup_adc(ADC_CLOCK_DIV_32);			// ADCON0
//	set_tris_a(0xF3);			// RA5,4,1,0 - , RA3,2 - .
	set_tris_b(0x01);   		// RB7-1 - , RB0 - .
	set_tris_c(0x00);			// RC7-0 - .
	set_tris_d(0x00);			// RD7-0 - .
	output_high(PIN_C0);		//   .
//	output_high(PIN_D2);		//  .
	output_high(PIN_D3);		// Reset LCD OFF.
	delay_us(1);
	reset_Displ();				//  .
	delay_ms(1);
	clr_Scr();					//  .
	delay_us(1);
	reset_Displ();				//  .
//	delay_ms(1);
//	clr_Scr();					//  .
	adress = 11;				//    .
	read_memory();				//  EEPROM.
	adress = 11;
	if (Constants[1] == 0xFF)	//  EEPROM ,  
	for (i=0; i<adress; i++)	//      EEPROM.
	{
	Constants[i] = Const_Temp[i];
	write_eeprom(i,Constants[i]);
	}
	Load_Regim();
	Power = 0;
	output_low(PIN_C0);			//   .
	output_high(PIN_B5);		//   Stand_BY.
	output_high(PIN_D2);		//  .
	clr_Scr();					//  .
	init_TDA7313();
	delay_ms(1);
	init_TDA7313();
/*---------------------------------------------------------------------------
                                  .
----------------------------------------------------------------------------*/
	do
	{
	if (inter == 1) Remote_Control();
	if (d == 3) Load_Regim();
	ext_int_edge(H_TO_L);
	enable_interrupts(int_ext);
	enable_interrupts(global);
	if (Volt[3] == 0x0040) output_high(PIN_D2);	//  .
		if (Change_Regim > 0)
		{
		Volt[4]--;
			if (Volt[4] == 0x0000)		
			{
			Volt[3]--;
				if (Volt[3] == 0x0000)
				{
				output_low(PIN_D2);	//  .
				Volt[3] = 0x0050;	//     
				Change_Regim = 0;	//   20 .
				RC5 = 0x0087;
				Volume[0]++;
				Remote_Control();
				output_high(PIN_D2);//  .
				}
			}
		}
	}
	while(1);						//  .
}
/*===========================================================================
							  .
===========================================================================*/	
void Load_Regim()
{
	Change_Regim = 1;
	RC5 = 0x0087;
	Balans_L[0] ++;
	Remote_Control();
	Change_Regim = 2;
	RC5 = 0x0087;
	Bass[0] ++;
	Remote_Control();
	Change_Regim = 3;
	RC5 = 0x0087;
	Treble[0] ++;
	Remote_Control();
	Change_Regim = 0;
	RC5 = 0x0087;
	Volume[0] ++;
	Remote_Control();
	d = 0;
	return;
}
/*===========================================================================
					    TDA7313.
===========================================================================*/	
void init_TDA7313()
{
	i2c_start();
	i2c_write(0x88);				//   TDA7313.
	i2c_write(Volume[0]);			//  .	
	i2c_write(Speaker[1] + 0x80);	// Speaker LF = 0 db.0x80
	i2c_write(Speaker[2] + 0xA0);	// Speaker RF = 0 db.0xA0
	i2c_write(Speaker[3] + 0xC0);	// Speaker LR = 0 db.0xC0
	i2c_write(Speaker[4] + 0xE0);	// Speaker RR = 0 db.0xE0
	i2c_write(0x40);				//  ,  1.
	i2c_write(Bass[0]    + 0x60);	// Bass.
	i2c_write(Treble[0]  + 0x70);	// Treble.
	i2c_stop();

	return;
}
//---------------------------------------------------------------------------
void Load_Volume()
{
    i2c_start();
	i2c_write(0x88);				//   TDA7313.
	i2c_write(Volume[0]);			//   
	i2c_stop();
}
//---------------------------------------------------------------------------
void Load_Balans()
{
	i2c_start();
	i2c_write(0x88);				//   TDA7313.
	i2c_write(Speaker[1] + 0x80);	// Speaker LF = 0 db. 0x80
	i2c_write(Speaker[2] + 0xA0);	// Speaker RF = 0 db. 0xA0
	i2c_write(Speaker[3] + 0xC0);	// Speaker LR = 0 db. 0xC0
	i2c_write(Speaker[4] + 0xE0);	// Speaker RR = 0 db. 0xE0
	i2c_stop();
}
//---------------------------------------------------------------------------
void Load_Bass()
{
	i2c_start();
	i2c_write(0x88);				// 	
 	i2c_write(Bass[0] + 0x60);		// .
	i2c_stop();
}
//---------------------------------------------------------------------------
void Load_Treble()
{
	i2c_start();
	i2c_write(0x88);				// 
	i2c_write(Treble[0] + 0x70);	// .
	i2c_stop();
}
/*===========================================================================
							  .
===========================================================================*/	
void Infa()
{
	d = 9;
	while(d)
	{
	Digit[d] = buf_0[d];
	d--;
	}
	output_low(PIN_C5);				//    .
	output_high(PIN_C4);
	Ind_1 = Page;					//  .
	ColSimb = 7;					//    ,
	ColStolb = 0x38;				//  .
	Write_Screen();					//   .
//---------------------------------------------------------------------------	
	d = 9;
	while(d)
	{
	Digit[d] = ' ';					//  .
	d--;
	}
	if (Change_Regim == 0)
	{
	Digit[1] = '';
	Digit[2] = '';
		if (Volume[0] > 0)
		{
		Digit[6] = '-';
		}
	}
	if (Change_Regim == 2) tembr_ind();
	if (Change_Regim == 3) tembr_ind();
	num[0] = Temp[0];
//num[0] = Volt[4];
	WORD_to_BCD();
	Digit[3] = ' ';
	Digit[4] = num[4];
	Digit[5] = num[3];
//Digit[6] = num[2];
//Digit[7] = num[1];
	if (Change_Regim == 1)
	{
	d = 9;
	while(d)
		{
		Digit[d] = buf_9[d];
		d--;
		}
	}
	output_high(PIN_C5);			//    .
	output_low(PIN_C4);
	Ind_1 = Page;					//  .
	ColSimb = 7;					// 7   ,
	ColStolb = 0x3F;				//  .
	Write_Screen();					//   .
//---------------------------------------------------------------------------	
	if (Change_Regim == 2)
	{
	Digit[1] = ' ';
	Digit[2] = ' ';
	Digit[3] = '';
	Digit[4] = '';
	Digit[5] = ' ';
	Digit[6] = ' ';
	Digit[7] = ' ';
	}
	else
	{
		if (Change_Regim == 1)
		{
		num[0] = Balans_L[0];
		WORD_to_BCD();
		Digit[1] = '';
		Digit[2] = '';
		Digit[3] = ' ';
		Digit[4] = num[4];
		Digit[5] = num[3];
		Digit[6] = ' ';
		Digit[7] = ' ';
			if (Balans_L[0] > 0)
			{
			Digit[6] = '-';
			}
		}
		else
		{
			d = 9;
			while(d)
			{
			Digit[d] = ' ';					//  .
			d--;
			}
		}
	}
	output_low(PIN_C5);				//    .
	output_high(PIN_C4);
	Ind_1 = 4;						//  .
	ColSimb = 7;					// 7   ,
	ColStolb = 0x3C;				//  .
	Write_Screen();					//   .
//---------------------------------------------------------------------------
		if (Change_Regim == 3)
	{
	Digit[1] = ' ';
	Digit[2] = ' ';
	Digit[3] = ' ';
	Digit[4] = '';
	Digit[5] = '';
	Digit[6] = ' ';
	Digit[7] = ' ';
	}
	else
	{
		if (Change_Regim == 1)
		{
		num[0] = Balans_R[0];
		WORD_to_BCD();
		Digit[1] = ' ';
		Digit[2] = '';
		Digit[3] = '';
		Digit[4] = ' ';
		Digit[5] = num[4];
		Digit[6] = num[3];
		Digit[7] = ' ';
			if (Balans_R[0] > 0)
			{
			Digit[7] = '-';
			}
		}
		else
		{
			d = 9;
			while(d)
			{
			Digit[d] = ' ';					//  .
			d--;
			}
		}
	}
	output_high(PIN_C5);			//    .
	output_low(PIN_C4);
	Ind_1 = 4;						//  .
	ColSimb = 7;					// 7   ,
	ColStolb = 0x3C;				//  .
	Write_Screen();					//   .
//---------------------------------------------------------------------------
	Analog_Signal();
	return;
}
//---------------------------------------------------------------------------
void tembr_ind()
{
	Temp[2] = Temp[0] >> 3;			//   .
	Tembr_dB();
	Digit[1] = '';
	Digit[2] = '';
	if (Temp[2] == 1)
	{
	Digit[6] = '+';
	}
	else
	{
	Digit[6] = '-';
	}
	if (Temp[0] == 0) Digit[6] = ' ';
	return;
}
/*===========================================================================
				     .
===========================================================================*/
void Tembr_dB()
{
	if 		(Temp[0] == 0)	Temp[0] = 14;
	else if (Temp[0] == 1)	Temp[0] = 12;
	else if (Temp[0] == 2)	Temp[0] = 10;
	else if (Temp[0] == 3)	Temp[0] = 8;
	else if (Temp[0] == 4)	Temp[0] = 6;
	else if (Temp[0] == 5)	Temp[0] = 4;
	else if (Temp[0] == 6)	Temp[0] = 2;
	else if (Temp[0] == 7)	Temp[0] = 0;
	else if (Temp[0] == 8)	Temp[0] = 14;
	else if (Temp[0] == 9)	Temp[0] = 12;
	else if (Temp[0] == 10)	Temp[0] = 10;
	else if (Temp[0] == 11)	Temp[0] = 8;
	else if (Temp[0] == 12)	Temp[0] = 6;
	else if (Temp[0] == 13)	Temp[0] = 4;
	else if (Temp[0] == 14)	Temp[0] = 2;
	else if (Temp[0] == 15)	Temp[0] = 0;
	return;
}
/*===========================================================================
							  EEPROM.
===========================================================================*/
void read_memory()
{
	while(adress)
	{
	Constants[adress] = read_eeprom(adress);
	adress--;
	}
	Volume[0]  = Constants[1];
	Bass[0]    = Constants[2];
	Bass[2]    = Constants[3];
	Treble[0]  = Constants[4];
	Treble[2]  = Constants[5];
	Speaker[1] = Constants[6];
	Speaker[2] = Constants[7];
	Speaker[3] = Constants[8];
	Speaker[4] = Constants[9];
	Balans_L[0] = Speaker[1];
	Balans_R[0] = Speaker[2];
	return;
}
/*===========================================================================
							  EEPROM.
===========================================================================*/
void write_memory()
{
	for (i=0; i<11; i++)		//      EEPROM.
	{
	write_eeprom(i,Constants[i]);
	}
	return;
}
/*===========================================================================
                         BCD e.
===========================================================================*/
void char WORD_to_BCD()
{
unsigned int16 high = 0;			// .    .
unsigned int16 low = 0;
	num[1] = 0;
	num[2] = 0;
	num[3] = 0;
	num[4] = 0;
	low = num[0];
	high = 0;
	num[4] = low;
	while (num[4] >= 10)    //     .
	{
	high++;					// +1  .
	low -= 10;
	num[4] = low;
	num[3] = high;
	}
	low = high;
	high = 0;
	while (num[3] >= 10)	//     .
	{
	high++;					// +1  .
	low -= 10;
	num[3] = low;
	num[2] = high;
	}
	low = high;
	high = 0;
	while (num[2] >= 10)	//     .
	{
	high++;
	low -= 10;
	num[2] = low;
	num[1] = high;
	}
	return;
}
//==========================================================================